Codeforces Round #436 (Div. 2) E. Fire

2024-01-25 00:32
文章标签 codeforces round div fire 436

本文主要是介绍Codeforces Round #436 (Div. 2) E. Fire,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

Description

Polycarp is in really serious trouble — his house is on fire! It’s time to save the most valuable items. Polycarp estimated that it would take ti seconds to save i-th item. In addition, for each item, he estimated the value of di — the moment after which the item i will be completely burned and will no longer be valuable for him at all. In particular, if ti ≥ di, then i-th item cannot be saved.

Given the values pi for each of the items, find a set of items that Polycarp can save such that the total value of this items is maximum possible. Polycarp saves the items one after another. For example, if he takes item a first, and then item b, then the item a will be saved in ta seconds, and the item b — in ta + tb seconds after fire started.

Input

The first line contains a single integer n (1 ≤ n ≤ 100) — the number of items in Polycarp’s house.

Each of the following n lines contains three integers ti, di, pi (1 ≤ ti ≤ 20, 1 ≤ di ≤ 2 000, 1 ≤ pi ≤ 20) — the time needed to save the item i, the time after which the item i will burn completely and the value of item i.

Output

In the first line print the maximum possible total value of the set of saved items. In the second line print one integer m — the number of items in the desired set. In the third line print m distinct integers — numbers of the saved items in the order Polycarp saves them. Items are 1-indexed in the same order in which they appear in the input. If there are several answers, print any of them.

Examples

input
3
3 7 4
2 6 5
3 7 6
output
11
2
2 3 
input
2
5 6 1
3 3 5
output
1
1
1 

题目大意

有n件物品,拯救第i件需要时间ti,价值为pi,到达时间di时物品会被烧毁。问能拯救的最大价值及拯救的物品标号。

解题思路

先将所有物品按照烧毁的时间排序,然后01背包,记录路径。
状态转移方程:
j>=a[i].d||a[i].t>j时,dp[i][j]=dp[i-1][j];
其他情况下, dp[i][j]=max(dp[i-1][j],dp[i-1][j-a[i].t]+a[i].p)。

代码实现

#include<iostream>
#include<cstring>
#include<cmath>
#include<cstdio>
#include<algorithm>
#include<vector>
using namespace std;
#define maxn 2007
vector<int>res;
struct node
{int t;int d;int p;int index;
} a[107];
int dp[107][maxn];
int mark[107][maxn];
bool cmp(node x ,node y)
{return x.d<y.d;
}
int main()
{int n,ans,pos;while(~scanf("%d",&n)){ans=0,pos=0;memset(dp,0,sizeof(dp));memset(mark,-1,sizeof(mark));for(int i=1; i<=n; i++){scanf("%d %d %d",&a[i].t,&a[i].d,&a[i].p);a[i].index=i;}sort(a+1,a+n+1,cmp);for(int i=1; i<=n; i++){for(int j=1; j<=2000;j++){dp[i][j]=dp[i-1][j];if(!(j>=a[i].d||a[i].t>j)){if(dp[i-1][j-a[i].t]+a[i].p>dp[i][j]){dp[i][j]=dp[i-1][j-a[i].t]+a[i].p;mark[i][j]=i;}}}}for(int j=1;j<=2000;j++){if(ans<dp[n][j]){ans=dp[n][j];pos=j;}}printf("%d\n",ans);res.clear();int maxx=n;while(pos>0&&maxx>0){if(mark[maxx][pos]>0){res.push_back(a[mark[maxx][pos]].index);pos-=a[mark[maxx][pos]].t;maxx--;}elsemaxx--;}int length=res.size();reverse(res.begin(),res.end());printf("%d\n",length);for(int i=0; i<length; i++)printf(i==length-1?"%d\n":"%d ",res[i]);}return 0;
}

这篇关于Codeforces Round #436 (Div. 2) E. Fire的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/641541

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There